/***prt_p16.h*******************************************/
#ifndef _JA_PRT_H
#define _JA_PRT_H

#define __task

#define OS_MSG_FAR  const
#define OS_MSG_NEAR const

#undef OS_VAR_LOC
#if defined(OS_USE_BANK1)
  #define OSM_BANK_CLEAR  asm("  clrf  status")
  #define OSM_INDR_SET
  #define OS_VAR_LOC      bank1
  #define OSM_BANK_SET    asm("  bsf  status, 5")
#elif defined(OS_USE_BANK2)
  #define OSM_BANK_CLEAR  asm("  clrf  status")
  #define OSM_INDR_SET    asm("  bsf  status, 7")
  #define OS_VAR_LOC      bank2
  #define OSM_BANK_SET    asm("  bsf  status, 6")
#elif defined(OS_USE_BANK3)
  #define OSM_BANK_CLEAR  asm("  clrf  status")
  #define OSM_INDR_SET    asm("  bsf  status, 7")
  #define OS_VAR_LOC      bank3
  #define OSM_BANK_SET\
    asm("  bsf  status, 5");\
    asm("  bsf  status, 6")
#else
  #define OS_VAR_LOC
  #define OSM_BANK_SET
  #define OSM_BANK_CLEAR
  #define OSM_INDR_SET
#endif

#if (OS_MEM_MODEL & COMPACT)
  #define OS_USE_STACK
  #define OS_COOP_PARAMT OST_ADDRESS adr
  asm("  global _OS_Cooperate_");
  asm("  fncall _OS_Kernel, _OS_Cooperate_");
#endif

#define OSM_RTN_UNLOCKED\
{\
  asm("  global _OS_Return_UL");\
  asm("_OS_Return_UL:");\
}

#define OSM_RTN_LOCKED\
{\
  asm("  global _OS_Return_L");\
  asm("_OS_Return_L:");\
}

#ifndef OS_SCHED_LOCKED
  #define OSM_RET \
    asm("  global _OS_Return_UL");\
    asm("  ljmp   _OS_Return_UL")

  #define OS_Scheduler()\
  {\
    asm("  global _OS_Kernel");\
    asm("  fncall _main,_OS_Kernel");\
    asm("  ljmp _OS_Kernel");\
    asm("  global _OS_Kernel_Ret");\
    asm("_OS_Kernel_Ret:");\
    OS_Kernel();\
    OSM_RTN_UNLOCKED;\
  }
#else
  #define OSM_RET \
    asm("  global _OS_Return_L");\
    asm("  ljmp   _OS_Return_L")

  #define OS_Scheduler()\
  {\
    asm("  global _OS_Kernel");\
    asm("  fncall _main,_OS_Kernel");\
    asm("  ljmp _OS_Kernel");\
    OSM_RTN_UNLOCKED;\
  }
#endif

#if (OS_MEM_MODEL == (COMPACT + SMALL))

  #define OSM_PIC_VER\
    asm("  global   os_jmp_tbl, _OS_Cooperate_");\
    asm("save_address macro");\
    asm("  local    label,label_out");\
    asm("  movlw    low label_out");\
    asm("  ljmp     _OS_Cooperate_");\
    asm("label:");\
    asm("  psect    os_jmp");\
    asm("label_out: ljmp label")

  #define OS_Cooperate_Code()\
  {\
    OSM_BANK_CLEAR;\
    asm("  global ?_OS_Cooperate_, _os_cur_task");\
    asm("  movwf  ?_OS_Cooperate_");\
    OSM_BANK_SET;\
    asm("  incf   _os_cur_task & 0x7F,w");\
    asm("  movwf  fsr");\
    OSM_BANK_CLEAR;\
    asm("  movf   ?_OS_Cooperate_,w");\
    OSM_INDR_SET;\
    asm("  movwf  indf");\
    OSM_RET;\
  }

#elif (OS_MEM_MODEL == COMPACT)

  #define OSM_PIC_VER\
    asm("save_address macro");\
    asm("  local  label");\
    asm("  global ?_OS_Cooperate_, _OS_Cooperate_");\
    asm("  movlw  high label");\
    OSM_BANK_CLEAR;\
    asm("  movwf  ?_OS_Cooperate_ + 1");\
    asm("  movlw  low label");\
    asm("  ljmp   _OS_Cooperate_");\
    asm("label:")

  #define OS_Cooperate_Code()\
  {\
    asm("  global ?_OS_Cooperate_, _os_cur_task");\
    asm("  movwf  ?_OS_Cooperate_");\
    OSM_BANK_SET;\
    asm("  incf   _os_cur_task & 0x7F,w");\
    asm("  movwf  fsr");\
    OSM_BANK_CLEAR;\
    asm("  movf   ?_OS_Cooperate_,w");\
    OSM_INDR_SET;\
    asm("  movwf  indf");\
    asm("  incf   fsr");\
    asm("  movf   ?_OS_Cooperate_ + 1,w");\
    asm("  movwf  indf");\
    OSM_RET;\
  }


#elif (OS_MEM_MODEL == SMALL)

  #define OSM_PIC_VER\
    asm("  global os_jmp_tbl, _os_cur_task");\
    asm("save_address macro");\
    asm("  local  label,label_out");\
    asm("  incf   _os_cur_task & 0x7F,w");\
    asm("  movwf  fsr");\
    asm("  movlw  low label_out");\
    asm("  movwf  indf");\
    OSM_RET;\
    asm("label:");\
    asm("  psect os_jmp ");\
    asm("label_out: ljmp label")

#elif (OS_MEM_MODEL == NORMAL)

  #define OSM_PIC_VER\
    asm("save_address macro");\
    asm("  global _os_cur_task");\
    asm("  local  label");\
    asm("  incf   _os_cur_task & 0x7F,w");\
    asm("  movwf  fsr");\
    asm("  movlw  low label");\
    asm("  movwf  indf");\
    asm("  incf   fsr");\
    asm("  movlw  high label");\
    asm("  movwf  indf");\
    OSM_RET;\
    asm("label:")

#endif

#define OS_Cooperate()\
{\
  os_status.state_parts.timeout = FALSE;\
  asm("  save_address");\
}

#if (OS_MEM_MODEL & SMALL)
  #define OST_ADDRESS void near *

  extern OST_ADDRESS os_param;

  #define OS_Task_Switch()\
  {\
    asm("  global os_jmp_tbl");\
    asm("  movlw high os_jmp_tbl");\
    asm("  movwf pclath");\
    asm("  incf  _os_cur_task & 0x7F,w");\
    asm("  movwf fsr");\
    asm("  movf  indf,w");\
    asm("  movwf pcl");\
  }

  #define OSM_PIC_TBL\
    asm("task_init macro adr");\
    asm("  global _os_param, ?_OS_Task_Init_");\
    asm("  _os_param set ?_OS_Task_Init_");\
    asm("  local  label");\
    asm("  movlw  low label");\
    OSM_BANK_CLEAR;\
    asm("  movwf  _os_param");\
    asm("  psect  os_jmp");\
    asm("label:   ljmp adr")

  #if defined(OS_USE_PRIO) && defined(OST_WORKSPACE)
    #define OS_Task_Create(fn_name, tcb, prio, ws)\
    {\
      asm("  global _os_param");\
      asm("  fncall _OS_Kernel,_" #fn_name);\
      asm("  task_init _" #fn_name);\
      OS_Task_Init_(os_param, (OST_TASK_P)tcb, prio, ws);\
    }

  #elif defined(OS_USE_PRIO)
    #define OS_Task_Create(fn_name, tcb, prio)\
    {\
      asm("  global _os_param");\
      asm("  fncall _OS_Kernel,_" #fn_name);\
      asm("  task_init _" #fn_name);\
      OS_Task_Init_(os_param, (OST_TASK_P)tcb, prio);\
    }
  #elif defined(OST_WORKSPACE)
    #define OS_Task_Create(fn_name, tcb, ws)\
    {\
      asm("  global _os_param");\
      asm("  fncall _OS_Kernel,_" #fn_name);\
      asm("  task_init _" #fn_name);\
      OS_Task_Init_(os_param, (OST_TASK_P)tcb, ws);\
    }
  #else
    #define OS_Task_Create(fn_name, tcb)\
    {\
      asm("  global _os_param");\
      asm("  fncall _OS_Kernel,_" #fn_name);\
      asm("  task_init _" #fn_name);\
      OS_Task_Init_(os_param, (OST_TASK_P)tcb);\
    }
  #endif

#else //(OS_MEM_MODEL & SMALL)

  #define OS_Task_Switch()\
  {\
    asm("  incf  _os_cur_task & 0x7F,w");\
    asm("  movwf fsr");\
    asm("  incf  fsr");\
    asm("  movf  indf,w");\
    asm("  movwf pclath");\
    asm("  decf  fsr");\
    asm("  movf  indf,w");\
    asm("  movwf pcl");\
  }

  #define OS_Tree_Rest(fn_name)\
  {\
    asm("  fncall _OS_Kernel,_" #fn_name);\
  }

#endif //#if (OS_MEM_MODEL & SMALL)

#define OS_Dis_Int()  di()
#define OS_Ena_Int()  ei()

#ifndef OS_Is_Timer
  #define OS_Is_Timer() T0IF
#endif

#ifndef OS_Timer_Tick_Set
  #define OS_Timer_Tick_Set()\
  {\
    TMR0 -= OS_TMR_TICK;\
    T0IF = 0;\
  }
#endif

#endif // _JA_PRT_H
